<?php
header('Access-Control-Allow-Origin: *');
require_once("Rest.inc.php");
require_once '../init.php';

class djax_adrequests extends REST
{
	function djax_adrequest()
	{		
		$publisherid=isset($this->_request['publisherid'])?$this->_request['publisherid']:'';
		$width=isset($this->_request['adwidth'])?$this->_request['adwidth']:'';
		$height=isset($this->_request['adheight'])?$this->_request['adheight']:'';
		$keywords=isset($this->_request['keywords'])?$this->_request['keywords']:'';		
		$lattitude=isset($this->_request['latitude'])?$this->_request['latitude']:'';
		$longitude=isset($this->_request['longitude'])?$this->_request['longitude']:'';
		$clientip=isset($this->_request['ip'])?$this->_request['ip']:'';
		$layerstyle_type=isset($this->_request['layerstyle'])?$this->_request['layerstyle']:'';
		$systemtype=isset($this->_request['systemtype'])?$this->_request['systemtype']:'';
		
		if($GLOBALS['_MAX']['CONF']['database']['type']=='pgsql') {
			require_once MAX_PATH . '/lib/OA/Dal/Delivery/pgsql.php';
		} 
		else if($GLOBALS['_MAX']['CONF']['database']['type']=='mysqli') {
			require_once MAX_PATH . '/lib/OA/Dal/Delivery/mysqli.php';
		}
					
		$djax_layer=(!empty($layerstyle_type))?$layerstyle_type:'';
		$djax_input_header_data=$this->getallheaders();
		
	

		$systemtype=(!empty($djax_input_header_data['Systemtype']))?$djax_input_header_data['Systemtype']:'';
		$screen_width=(!empty($djax_input_header_data['Screenwidth']))?$djax_input_header_data['Screenwidth']:'';
		$screen_height=(!empty($djax_input_header_data['Screenheight']))?$djax_input_header_data['Screenheight']:'';
		$display_width=(!empty($djax_input_header_data['Displaywidth']))?$djax_input_header_data['Displaywidth']:'';
		$display_height=(!empty($djax_input_header_data['Displayheight']))?$djax_input_header_data['Displayheight']:'';
		$displaytype=(!empty($djax_input_header_data['Devicetype']))?$djax_input_header_data['Devicetype']:'';
		$devicebrand=(!empty($djax_input_header_data['Make']))?$djax_input_header_data['Make']:'';
		$devicemodel=(!empty($djax_input_header_data['Model']))?$djax_input_header_data['Model']:'';
		$deviceos=(!empty($djax_input_header_data['Os']))?$djax_input_header_data['Os']:'';
		$deviceosversion=(!empty($djax_input_header_data['Osv']))?$djax_input_header_data['Osv']:'';
		$is_js_enabled=(!empty($djax_input_header_data['Js']))?$djax_input_header_data['Js']:'';
		$carrier=(!empty($djax_input_header_data['Carrier']))?$djax_input_header_data['Carrier']:'';
		$language=(!empty($djax_input_header_data['Language']))?$djax_input_header_data['Language']:'';
		$useragent=(!empty($djax_input_header_data['Useragent']))?$djax_input_header_data['Useragent']:'';
		$device_appid=(!empty($djax_input_header_data['Appid']))?$djax_input_header_data['Appid']:'';
		$device_app_cat=(!empty($djax_input_header_data['App_cat']))?$djax_input_header_data['App_cat']:'';
		$device_app_sha1=(!empty($djax_input_header_data['Didsha1']))?$djax_input_header_data['Didsha1']:'';
		$device_app_md5=(!empty($djax_input_header_data['Didmd5']))?$djax_input_header_data['Didmd5']:'';
		$device_app_dpidsha1=(!empty($djax_input_header_data['Dpidsha1']))?$djax_input_header_data['Dpidsha1']:'';
		$device_app_dpidmd5=(!empty($djax_input_header_data['Dpidmd5']))?$djax_input_header_data['Dpidmd5']:'';
		$device_app_ipv6=(!empty($djax_input_header_data['Ipv6']))?$djax_input_header_data['Ipv6']:'';
		$udid=(!empty($djax_input_header_data['Udid']))?$djax_input_header_data['Udid']:'';
		$timezone=(!empty($djax_input_header_data['Timezone']))?$djax_input_header_data['Timezone']:'';
		$dataspeed=(!empty($djax_input_header_data['Dataspeed']))?$djax_input_header_data['Dataspeed']:'';
		$connection=(!empty($djax_input_header_data['Connection']))?$djax_input_header_data['Connection']:'';
		$connectiontype=(!empty($djax_input_header_data['Connectiontype']))?$djax_input_header_data['Connectiontype']:'';
		$username=(!empty($djax_input_header_data['Viewername']))?$djax_input_header_data['Viewername']:'';
		$useremail=(!empty($djax_input_header_data['Vieweremail']))?$djax_input_header_data['Vieweremail']:'';
		$userphone=(!empty($djax_input_header_data['Viewerphone']))?$djax_input_header_data['Viewerphone']:'';
		$userage=(!empty($djax_input_header_data['Viewerage']))?$djax_input_header_data['Viewerage']:'';
		$usergender=(!empty($djax_input_header_data['Viewergender']))?$djax_input_header_data['Viewergender']:'';
		$userid=(!empty($djax_input_header_data['Userid']))?$djax_input_header_data['Userid']:'';
		$table_prefix = $GLOBALS['_MAX']['CONF']['table']['prefix'];
		$pub_result = OA_Dal_Delivery_query("SELECT az.zone_id as zoneid FROM {$table_prefix}zones AS z JOIN {$table_prefix}ad_zone_assoc AS az ON az.zone_id=z.zoneid WHERE z.affiliateid =" . $publisherid." group by az.zone_id" );

		while ($pub_results = OA_Dal_Delivery_fetchAssoc($pub_result))
			{
			$zoneid = $pub_results['zoneid'];
			$zoneids=explode(',',$zoneid);
		
		    foreach($zoneids as $values)
			{
			$zoneid=$values;
			if(empty($zoneid) && empty($width) &&  empty($height) && empty($screen_width) && empty($screen_height) && empty($udid) && empty($device_appid) && empty($devicebrand) && empty($devicebrand) && empty($$devicemodel) && empty($deviceos))
			{
				return $this->response('Invalid Input,More Inputs required',400); 
			}
		    }
		$input_post_parameters = array(
			'zoneid'=>urlencode($zoneid),
			'width'=>urlencode($width),
			'height'=>urlencode($height),
			'zoneid'=>urlencode($zoneid),
			'keywords'=>urlencode($keywords),
			'lattitude'=>urlencode($lattitude),
			'longitude'=>urlencode($longitude),
			'systemtype'=>urlencode($systemtype),
			'ip'=>urlencode($clientip),
			'layerstyle'=>$djax_layer,
			'screenwidth'=>urlencode($screen_width),
			'screenheight'=>urlencode($screen_height),
			'displaywidth'=>urlencode($display_width),
			'displayheight'=>urlencode($display_height),
			'displaytype'=>urlencode($displaytype),
			'devicemodel'=>urlencode($devicemodel),
			'devicebrand'=> urlencode($devicebrand),
			'deviceos' => urlencode($deviceos),
			'deviceosversion'=>urlencode($deviceosversion),
			'is_js_enabled'=> urlencode($is_js_enabled),
			'carrier'=> urlencode($carrier),
			'country'=> urlencode($country),
			'countryname'=>$country_name,
			'region'=> urlencode($region),
			'city'=> urlencode($city),
			'useragent'=>urlencode($useragent),
			'language'=>urlencode($language),
			'postalcode'=>urlencode($postalcode),
			'device_appid'=>urlencode($device_appid),
			'device_app_cat'=>urlencode($device_app_cat),
			'device_app_sha1'=>urlencode($device_app_sha1),
			'device_app_md5'=>urlencode($device_app_md5),
			'device_app_dpidsha1'=>urlencode($device_app_dpidsha1),
			'device_app_dpidmd5'=>urlencode($device_app_dpidmd5),
			'device_app_ipv6'=>urlencode($device_app_ipv6),
			'udid'=>urlencode($udid),
			'timezone'=>$timezone,
			'dataspeed'=>$dataspeed,
			'connection'=>$connection,
			'connectiontype'=>$connectiontype,
			'Viewername'=>$username,
			'Vieweremail'=>$useremail,
			'Viewerphone'=>$userphone,
			'Viewergender'=>$usergender,
			'Viewerage'=>$userage,
			'userid'=>$userid
		);
		
	
		
		if($custom_param) {
			$input_post_parameters=array_merge($input_post_parameters,$custom_param);
		}
		
		
		$conf = $GLOBALS['_MAX']['CONF']['webpath']['admin'];						
		$protocol = (!empty($_SERVER['HTTPS']) && $_SERVER['HTTPS'] !== 'off' || $_SERVER['SERVER_PORT'] == 443) ? "https://" : "http://";
		
		
		 $url= $protocol.$conf."/plugins/mobileAdsDelivery/djax_showads.php";
		
		header('Content-type: text/json');
		header('Content-type: application/json');
        
		$additiona_param=$_GET;
		$totalparam=array_merge($input_post_parameters,$additiona_param);
		$totalparam['zoneid']=$zoneid;
		$ch = curl_init($url);     
		curl_setopt($ch, CURLOPT_POST, 1);
		curl_setopt($ch, CURLOPT_HEADER,'TRUE');
		curl_setopt($ch, CURLOPT_POSTFIELDS,$totalparam);
		curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
		$results[]=json_decode(curl_exec($ch));
		
		curl_close($ch);
	}	
	  $djax_response=array(
						'response'=>'success',
						'ads'=> $results
						);
	   if(!empty($djax_response))
		{	
			print_r(json_encode($djax_response));
            
		}
		else
		{
			return $this->response('No ads avilable',204); 
		}
        
	}

	
	
    function getallheaders()
    {
        $headers = array();

        foreach ($_SERVER as $name => $value)
        {
		    if (substr($name, 0, 5) == 'HTTP_')
		    {
		       $headers[str_replace(' ', '-', ucwords(strtolower(str_replace('_', ' ', substr($name, 5)))))] = $value;
		    }
        }

       return $headers;
    }
	


}
 function OX_Delivery_logMessage()
 {
	 return true;
 }
$obj=new djax_adrequests();

$results= $obj->djax_adrequest();

print_r($results);
		exit;
?>
